document.addEventListener('DOMContentLoaded', function () {
    function send_order(order, nonce, parent)
    {
        jQuery(".shipquik_loader_" + order).show();
        jQuery('.send-order_' + order).hide();
        jQuery('.print-label_' + order).hide();
    
        var data = {
            'action': 'process_sendorder',
            'nonce': nonce,
            'date': Date.now(),
            'key': order
        };
        jQuery.ajax({
            type: "POST",
            url: SHIP_QUIK_Ajax.ajaxurl,
            data: data,
            cache: false,
            dataType: 'JSON',
            success: function (response) {
                jQuery(".shipquik_loader_" + order).hide();
                if (response.status == 200 && response.hasOwnProperty('data')) {
                    jQuery(parent).parent().html(
                        '<span title="Etiqueta pendiente" class="material-symbols-outlined ship-quik-print-label ship-quik-print-label_' + order + '" data-filetype="' + response.data + '" data-key="' + order + '">print</span>'
                    );
                    jQuery('.ship-quik-print-label').on('click', function () {
                        var nonce = jQuery('html').data('sendordernonce');
                        var order_id = jQuery(this).data('key');
                        var filetype = jQuery(this).data('filetype');
                
                        print_order(order_id, nonce, filetype, this);
                    });
                } else {
                    jQuery(parent).html(response.message);
                }
            }
        });
    }

    jQuery('.ship-quik-send-order').on('click', function () {
        var order_id = jQuery(this).data('key');
        var pickup_date = jQuery('.ship-quik-pickdate_' + order_id).val();

        if (pickup_date == '') {
            alert('Debe introducir una fecha de recogída');
        } else {
            var nonce = jQuery('html').data('sendordernonce');
    
            send_order(order_id, nonce, this);
        }
    });

    function print_order(order, nonce, filetype, parent)
    {
        jQuery('#ship-quik-dialog-label-content').html('');
        var data = {
            'action': 'print_label',
            'nonce': nonce,
            'date': Date.now(),
            'key': order,
            'filetype': filetype
        };
        jQuery.ajax({
            type: "POST",
            url: SHIP_QUIK_Ajax.ajaxurl,
            data: data,
            cache: false,
            dataType: "JSON",
            success: function (response) {
                jQuery('#ship-quik-dialog-label').dialog({
                    dialogClass: 'ship-quik-dialog-label',
                    autoOpen: false,
                    draggable: false,
                    width: '70%',
                    modal: true,
                    resizable: false,
                    closeOnEscape: true,
                    position: {
                        my: "center",
                        at: "top",
                        of: document
                    },
                    open: function () {
                    },
                    create: function () {
                    }
                });

                jQuery.each(response.labels, function() {
                    if (response.labelsMimeType == 'image/png') {
                        jQuery('#ship-quik-dialog-label-content').append('<img style="display: block; width: 100%; height: 600px" src="' + this + '#toolbar=1&navpanes=0&scrollbar=0" />');
                    } else {
                        jQuery('#ship-quik-dialog-label-content').append('<embed style="display: block; width: 100%; height: 600px;" src="' + this + '#toolbar=0&navpanes=0&scrollbar=0" type="' + response.labelsMimeType + '" />');
                    }
                    jQuery(parent).html('update');
                });

                jQuery('#ship-quik-dialog-label').dialog('open');
            }
        });
    }

    jQuery('.ship-quik-print-label').on('click', function () {
        var nonce = jQuery('html').data('sendordernonce');
        var order_id = jQuery(this).data('key');
        var filetype = jQuery(this).data('filetype');

        print_order(order_id, nonce, filetype, this);
    });


    function stripe_dialog()
    {
        const stripe = Stripe(SHIP_QUIK_Ajax.stkey);
        const paymentReturnSubmitUrl = jQuery('meta[name="paymentSubmitReturnUrl"]').attr("content");
        const paymentReturnCancelUrl = jQuery('meta[name="paymentCancelReturnUrl"]').attr("content");

        var elements;

        initialize();

        document.querySelector("#payment-form").addEventListener("submit", handleSubmit);
        document.querySelector("#cancel").addEventListener("click", handleCancel);
    
        async function initialize() {

            const { clientSecret } = { clientSecret : jQuery('meta[name="paymentKey"]').attr("content") };

            elements = stripe.elements({ clientSecret });
    
            const paymentElement = elements.create("payment");
            paymentElement.mount("#payment-element");
        }
    
        async function handleSubmit(e) {
            e.preventDefault();
    
            const { error } = await stripe.confirmPayment({
                elements,
                confirmParams: {
                    return_url: paymentReturnSubmitUrl + "&payment_return=1",
                },
            });
        }
        async function handleCancel(e) {
            e.preventDefault();

            jQuery('#ship-quik-dialog-payment').dialog('close');
            window.location.href = paymentReturnCancelUrl;
        }
    }

    function process_orders(orders, nonce) {
        orders.forEach(function (order_id) {
            send_order(order_id, nonce, jQuery('.send-order_' + order_id));
            console.log(jQuery('.send-order_' . order_id));
        }, this);

        jQuery("#aceptar").show();
    }

    if (jQuery('body').hasClass('edit-php') && jQuery('body').hasClass('post-type-shop_order')) {
        const paymentKey = jQuery('meta[name="paymentKey"]').attr("content");
        const paymentReturn = jQuery('meta[name="paymentReturn"]').attr("content");

        if (paymentKey != undefined && paymentKey != 'nopaymentkey') {
            console.log('entra_stripe');

            jQuery('#ship-quik-dialog-payment').dialog({
                dialogClass: 'ship-quik-dialog-payment',
                autoOpen: false,
                draggable: false,
                width: '70%',
                modal: true,
                resizable: false,
                closeOnEscape: true,
                position: {
                    my: "center",
                    at: "top",
                    of: document
                },
                open: function () {
                },
                create: function () {
                    jQuery(".ui-dialog-titlebar").hide();
                }
            });

            jQuery('#payment-total').html(jQuery('meta[name="paymentTotal"]').attr("content"));
            jQuery('#ship-quik-dialog-payment').dialog('open');

            stripe_dialog();
        }
        // if (paymentReturn != undefined && paymentReturn == 'succeeded') {
        //     console.log('entra_return');
        //     //const ordersId = jQuery('meta[name="ordersId"]').attr("content");
        //     //var nonce = jQuery('html').attr('data-sendordernonce');
        //     //process_orders(ordersId.split(","), nonce);
        // }
    }

    jQuery('.ship-quik-pickdate').on('input', function () {
        var nonce = jQuery('html').data('sendordernonce');
        var order_id = jQuery(this).data('key');

        var parent = this;
        jQuery.ajax({
            type: "POST",
            url: SHIP_QUIK_Ajax.ajaxurl,
            data: {
                'action': 'order_pickup',
                'order_id'    : order_id,
                'pickup_date' : jQuery(parent).val(),
                'pickup_time' : jQuery(parent).prev().val(),
                'nonce'       : nonce
            },
            cache: false,
            dataType: "json",
            success: function(response) {
                if (response.status == 200 && response.hasOwnProperty('error')) {
                    alert(response.error);
                } else {
                    jQuery(parent).removeClass('ship-quik-pickdate-red');
                    if (jQuery(parent).val() != response.date) {
                        var today  = new Date(response.date);
                        alert("La fecha seleccionada no esta disponible, se asignará el día " + today.toLocaleDateString("es-ES"));
                        jQuery(parent).val(response.date);
                    }
                }
            }
        });
    });

    jQuery('.ship-quik-picktime').on('change', function () {
        var nonce = jQuery('html').data('sendordernonce');
        var order_id = jQuery(this).data('key');

        var parent = this;
        jQuery.ajax({
            type: "POST",
            url: SHIP_QUIK_Ajax.ajaxurl,
            data: {
                'action': 'order_pickup',
                'order_id'    : order_id,
                'pickup_date' : jQuery(parent).next().val(),
                'pickup_time' : jQuery(parent).val(),
                'nonce'       : nonce
            },
            cache: false,
            dataType: "json",
            success: function(response) {
                if (response.status == 200 && response.hasOwnProperty('error')) {
                    alert("Introduzca una fecha correcta.");
                } else {
                    jQuery(parent).removeClass('ship-quik-picktime-red');
                }
            }
        });
    });
});